﻿using System;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Ink;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using System.Collections.ObjectModel;
using System.ComponentModel;
using Infragistics.Persistence;
using System.IO;
using Infragistics.Controls.Layouts;
using System.Collections.Generic;
using Infragistics.Persistence.Primitives;
using System.Windows.Threading;

namespace SilverlightApplication1
{
	public partial class MainPage : UserControl
	{
		public MainPage()
		{
			// Required to initialize variables
			InitializeComponent();
            this.Loaded += new RoutedEventHandler(MainPage_Loaded);
            
		}
        
        private void MainPage_Loaded(object sender, RoutedEventArgs e)
        {                
            GenerateTiles();
        }                

        private void btnSave_Click(object sender, System.Windows.RoutedEventArgs e)
        {
            var memStream = PersistenceManager.Save(tileManager);
            FileStream fs = new FileStream(@"D:\manState.dat", FileMode.Create);
            fs.Write(memStream.ToArray(), 0, (int)memStream.Length);
            fs.Close();                                       
        }

        private void btnLoad_Click(object sender, System.Windows.RoutedEventArgs e)
        {
            if (File.Exists(@"D:\manState.dat"))
            {
                FileStream fs = new FileStream(@"D:\manState.dat", FileMode.Open);
                PersistenceManager.Load(tileManager, fs);
                fs.Close();     
            }
                
        }

        private void GenerateTiles()
        {
            var t1 = new XamTile();
            t1.Content = " Tile 1";

            XamTileManager.SetSerializationId(t1, t1.Content.ToString());

            tileManager.Items.Add(t1);

            var t2 = new XamTile();
            t2.Content = " Tile 2";

            XamTileManager.SetSerializationId(t2, t2.Content.ToString());

            XamTileManager.SetColumn(t2, 1);
            tileManager.Items.Add(t2);

            var t3 = new XamTile();
            t3.Content = " Tile 3";

            XamTileManager.SetSerializationId(t3, t3.Content.ToString());

            XamTileManager.SetRow(t3, 1);
            XamTileManager.SetColumnSpan(t3, 2);
            tileManager.Items.Add(t3);
        }
	}        
}